NC15665 maze(BFS)

链接:https://ac.nowcoder.com/acm/problem/15665

题目描述

小明来到一个由n x m个格子组成的迷宫,有些格子是陷阱,用’#‘表示,小明进入陷阱就会死亡,’.'表示没有陷阱。小明所在的位置用’S’表示,目的地用’T’表示。

小明只能向上下左右相邻的格子移动,每移动一次花费1秒。

有q个单向传送阵,每个传送阵各有一个入口和一个出口,入口和出口都在迷宫的格子里,当走到或被传送到一个有传送阵入口的格子时,小明可以选择是否开启传送阵。如果开启传送阵,小明就会被传送到出口对应的格子里,这个过程会花费3秒;如果不开启传送阵,将不会发生任何事情,小明可以继续向上下左右四个方向移动。

一个格子可能既有多个入口,又有多个出口,小明可以选择任意一个入口开启传送阵。使用传送阵是非常危险的,因为有的传送阵的出口在陷阱里,如果小明使用这样的传送阵,那他就会死亡。也有一些传送阵的入口在陷阱里,这样的传送阵是没有用的,因为小明不能活着进入。请告诉小明活着到达目的地的最短时间。

输入描述:

有多组数据。对于每组数据:
第一行有三个整数n,m,q(2≤ n,m≤300,0≤ q ≤ 1000)。
接下来是一个n行m列的矩阵,表示迷宫。
最后q行,每行四个整数x1,y1,x2,y2(0≤ x1,x2< n,0≤ y1,y2< m),表示一个传送阵的入口在x1行y1列,出口在x2行y2列。

输出描述:

如果小明能够活着到达目的地,则输出最短时间,否则输出-1。

输入

5 5 1
…S…

.###.

…T…
1 2 3 3
5 5 1
…S…

.###.

…T…
3 3 1 2
5 5 1
S.#…
…#…
###…

…T
0 1 0 2
4 4 2
S#.T
.#.#
.#.#
.#.#
0 0 0 3
2 0 2 2

输出

6
8
-1
3


solution

BFS。因为存在直接传送的情况花费3秒,其他上下左右移动花费1秒,如果按照普通的BFS逐步遍历,就可能存在不是最优的问题,所以要用优先队列按照花费的时间从小到大排序。

code

#include 
using namespace std;
typedef long long ll;
const int N = 1e5 + 5;
const ll mod = 1e9 + 7;
typedef pair<int, pair<int, int>> P;
#define fi first
#define se second
int n, m, q;
string mp[310];
bool vis[310][310];
map<pair<int, int>, vector<pair<int, int>>> Map;
int dx[4] = {0, 1, 0, -1};
int dy[4] = {1, 0, -1, 0};
int bfs() {
    int X = -1, Y = -1;
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < m; j++) {
            if (mp[i][j] == 'S') {
                X = i, Y = j;
                break;
            }
        }
    }
    priority_queue<P, vector<P>, greater<P>> q;
    q.push({0, {X, Y}});
    vis[X][Y] = true;
    while (!q.empty()) {
        P now = q.top();
        int x = now.se.fi, y = now.se.se;
        if (mp[x][y] == 'T') {
            return now.fi;
        }
        q.pop();
        for (int i = 0; i < 4; i++) {
            int tx = x + dx[i], ty = y + dy[i];
            if (tx < 0 || tx >= n || ty < 0 || ty >= m || vis[tx][ty] ||
                mp[tx][ty] == '#')
                continue;
            vis[tx][ty] = true;
            q.push({now.fi + 1, {tx, ty}});
        }
        for (auto i : Map[{x, y}]) {
            int tx = i.fi, ty = i.se;
            if (tx < 0 || tx >= n || ty < 0 || ty >= m || vis[tx][ty] ||
                mp[tx][ty] == '#')
                continue;
            q.push({now.fi + 3, {tx, ty}});
        }
    }
    return -1;
}
int main() {
    ios::sync_with_stdio(false), cin.tie(nullptr), cout.tie(nullptr);
    while (cin >> n >> m >> q) {
        for (int i = 0; i < n; i++) {
            cin >> mp[i];
        }
        memset(vis, false, sizeof(vis));
        Map.clear();
        for (int i = 1; i <= q; i++) {
            int a, b, c, d;
            cin >> a >> b >> c >> d;
            Map[{a, b}].push_back({c, d});
        }
        cout << bfs() << endl;
    }
    return 0;
}

你可能感兴趣的:(牛客练习,搜索)